// Generated by gencpp from file hector_uav_msgs/Compass.msg
// DO NOT EDIT!


#ifndef HECTOR_UAV_MSGS_MESSAGE_COMPASS_H
#define HECTOR_UAV_MSGS_MESSAGE_COMPASS_H


#include <string>
#include <vector>
#include <memory>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <std_msgs/Header.h>

namespace hector_uav_msgs
{
template <class ContainerAllocator>
struct Compass_
{
  typedef Compass_<ContainerAllocator> Type;

  Compass_()
    : header()
    , magnetic_heading(0.0)
    , declination(0.0)  {
    }
  Compass_(const ContainerAllocator& _alloc)
    : header(_alloc)
    , magnetic_heading(0.0)
    , declination(0.0)  {
  (void)_alloc;
    }



   typedef  ::std_msgs::Header_<ContainerAllocator>  _header_type;
  _header_type header;

   typedef float _magnetic_heading_type;
  _magnetic_heading_type magnetic_heading;

   typedef float _declination_type;
  _declination_type declination;





  typedef boost::shared_ptr< ::hector_uav_msgs::Compass_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::hector_uav_msgs::Compass_<ContainerAllocator> const> ConstPtr;

}; // struct Compass_

typedef ::hector_uav_msgs::Compass_<std::allocator<void> > Compass;

typedef boost::shared_ptr< ::hector_uav_msgs::Compass > CompassPtr;
typedef boost::shared_ptr< ::hector_uav_msgs::Compass const> CompassConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::hector_uav_msgs::Compass_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::hector_uav_msgs::Compass_<ContainerAllocator> >::stream(s, "", v);
return s;
}


template<typename ContainerAllocator1, typename ContainerAllocator2>
bool operator==(const ::hector_uav_msgs::Compass_<ContainerAllocator1> & lhs, const ::hector_uav_msgs::Compass_<ContainerAllocator2> & rhs)
{
  return lhs.header == rhs.header &&
    lhs.magnetic_heading == rhs.magnetic_heading &&
    lhs.declination == rhs.declination;
}

template<typename ContainerAllocator1, typename ContainerAllocator2>
bool operator!=(const ::hector_uav_msgs::Compass_<ContainerAllocator1> & lhs, const ::hector_uav_msgs::Compass_<ContainerAllocator2> & rhs)
{
  return !(lhs == rhs);
}


} // namespace hector_uav_msgs

namespace ros
{
namespace message_traits
{





template <class ContainerAllocator>
struct IsFixedSize< ::hector_uav_msgs::Compass_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::hector_uav_msgs::Compass_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::hector_uav_msgs::Compass_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::hector_uav_msgs::Compass_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::hector_uav_msgs::Compass_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::hector_uav_msgs::Compass_<ContainerAllocator> const>
  : TrueType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::hector_uav_msgs::Compass_<ContainerAllocator> >
{
  static const char* value()
  {
    return "69b5db73a2f794a5a815baf6b84a4be5";
  }

  static const char* value(const ::hector_uav_msgs::Compass_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x69b5db73a2f794a5ULL;
  static const uint64_t static_value2 = 0xa815baf6b84a4be5ULL;
};

template<class ContainerAllocator>
struct DataType< ::hector_uav_msgs::Compass_<ContainerAllocator> >
{
  static const char* value()
  {
    return "hector_uav_msgs/Compass";
  }

  static const char* value(const ::hector_uav_msgs::Compass_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::hector_uav_msgs::Compass_<ContainerAllocator> >
{
  static const char* value()
  {
    return "Header header\n"
"float32 magnetic_heading\n"
"float32 declination\n"
"\n"
"\n"
"================================================================================\n"
"MSG: std_msgs/Header\n"
"# Standard metadata for higher-level stamped data types.\n"
"# This is generally used to communicate timestamped data \n"
"# in a particular coordinate frame.\n"
"# \n"
"# sequence ID: consecutively increasing ID \n"
"uint32 seq\n"
"#Two-integer timestamp that is expressed as:\n"
"# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')\n"
"# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')\n"
"# time-handling sugar is provided by the client library\n"
"time stamp\n"
"#Frame this data is associated with\n"
"string frame_id\n"
;
  }

  static const char* value(const ::hector_uav_msgs::Compass_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::hector_uav_msgs::Compass_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.header);
      stream.next(m.magnetic_heading);
      stream.next(m.declination);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER
  }; // struct Compass_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::hector_uav_msgs::Compass_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::hector_uav_msgs::Compass_<ContainerAllocator>& v)
  {
    s << indent << "header: ";
    s << std::endl;
    Printer< ::std_msgs::Header_<ContainerAllocator> >::stream(s, indent + "  ", v.header);
    s << indent << "magnetic_heading: ";
    Printer<float>::stream(s, indent + "  ", v.magnetic_heading);
    s << indent << "declination: ";
    Printer<float>::stream(s, indent + "  ", v.declination);
  }
};

} // namespace message_operations
} // namespace ros

#endif // HECTOR_UAV_MSGS_MESSAGE_COMPASS_H
